pro bpd_edit,x_save,y_save,lines,n_pnts,edt_line,n_save
;
;+
; NAME: BPD_EDIT
; PURPOSE:
;   To edit data arrays using the bitpad
; CATEGORY:
;   BITPAD, data entry
; CALLING SEQUENCE:
;    bpd_edit,x_save,y_save,lines,n_pnts,edt_line,n_save
; INPUTS:
; OPTIONAL INPUT PARAMETERS:
; KEYWORD PARAMETERS:
; OUTPUTS:
; OPTIONAL OUTPUT PARAMETERS:
; COMMON BLOCKS:
; SIDE EFFECTS:
; RESTRICTIONS:
; PROCEDURE:
; MODIFICATION HISTORY:
;     Created by J.D. Trickey 15-DEC-1992
;-
;
common BPD_common,xtype,xmax,xmin,xscale,bp_x_offset,$
                  ytype,ymax,ymin,yscale,bp_y_offset,rot_angle 
;
fill=99999.9
;
err=1
while (err eq 1) do begin
   print,'On the Bitpad, enter the edit point'
   bitpad_read,bp_x,bp_y,int3,err
endwhile
;
if (xtype eq 0) then begin
   point_x=float((bp_x-bp_x_offset)*cos(rot_angle)+$
              (bp_y-bp_y_offset)*sin(rot_angle))*xscale+xmin
endif else begin
   point_x=10^(float((bp_x-bp_x_offset)*cos(rot_angle)+$
              (bp_y-bp_y_offset)*sin(rot_angle))*xscale+xmin)
endelse
if (ytype eq 0) then begin
   point_y=float(-1*(bp_x-bp_x_offset)*sin(rot_angle)+$
                 (bp_y-bp_y_offset)*cos(rot_angle))*yscale+ymin
endif else begin
   point_y=10^(float(-1*(bp_x-bp_x_offset)*sin(rot_angle)+$
                 (bp_y-bp_y_offset)*cos(rot_angle))*yscale+ymin)
endelse
;
dis=sqrt((point_x-x_save(edt_line-1,*))^2+(point_y-y_save(edt_line-1,*))^2)
min_v=min(dis,pos)
;
plot,x_save(0,0:n_pnts(0)-1),y_save(0,0:n_pnts(0)-1),$
     psym=-3,max_value=fill-1.,xtype=xtype,ytype=ytype 
if lines ge 2 then for i=2,lines do $
    oplot,x_save(i-1,0:n_pnts(i-1)-1),$
          y_save(i-1,0:n_pnts(i-1)-1),psym=-3,max_value=fill-1.
if (x_save(edt_line-1,pos) ge fill) then begin
   if (pos ne 0) then begin
      oplot,[x_save(edt_line-1,pos-1)],$
            [!y.crange(1)-y_save(edt_line-1,pos-1)+!y.crange(0)],psym=5
   endif else begin
      oplot,[x_save(edt_line-1,pos+1)],$
            [!y.crange(1)-y_save(edt_line-1,pos+1)+!y.crange(0)],psym=5
   endelse
endif else begin
   oplot,[x_save(edt_line-1,pos)],[y_save(edt_line-1,pos)],psym=6
endelse
;
;
err=1
while (err eq 1) do begin
   err2=1
   while (err2 eq 1) do begin
      print,'On the Bitpad, enter the command'
      bitpad_read,bp_x,bp_y,int3,err2
      bpd_control,bp_x,bp_y,command
      if (command eq 0) then err2=1
   endwhile
   case command of
     1: err=0   ; END ENTRY
     2: begin     ; DELETE LAST POINT
           if (n_pnts(edt_line-1) gt 0) then n_pnts(edt_line-1)=n_pnts(edt_line-1)-1
           if (n_pnts(edt_line-1) eq 0) then begin
              for i=edt_line,lines-1 do begin
                 x_save(i-1,0:n_pnts(i)-1)=x_save(i,0:n_pnts(i)-1)
                 y_save(i-1,0:n_pnts(i)-1)=y_save(i,0:n_pnts(i)-1)
              endfor
              lines=lines-1
              print,'--- Line Deleted ---'
              err=0
           endif
        end
     3: begin   ; DELETE INDICATED POINT
           if (pos lt n_pnts(edt_line-1)-1) then begin
              x_save(edt_line-1,pos:n_pnts(edt_line-1)-2)=$
                   x_save(edt_line-1,pos+1:n_pnts(edt_line-1)-1)
              y_save(edt_line-1,pos:n_pnts(edt_line-1)-2)=$
                   y_save(edt_line-1,pos+1:n_pnts(edt_line-1)-1)
           endif
           if (n_pnts(edt_line-1) gt 0) then n_pnts(edt_line-1)=n_pnts(edt_line-1)-1
           if (n_pnts(edt_line-1) eq 0) then begin
              for i=edt_line,lines-1 do begin
                 x_save(i-1,0:n_pnts(i)-1)=x_save(i,0:n_pnts(i)-1)
                 y_save(i-1,0:n_pnts(i)-1)=y_save(i,0:n_pnts(i)-1)
              endfor
              lines=lines-1
              print,'--- Line Deleted ---'
              err=0
           endif
        end
     4: begin  ; REPLACE POINT
           err2=1
           while (err2 eq 1) do begin
               print,'Enter the NEW point'
               bitpad_read,bp_x,bp_y,int3,err2
               bpd_control,bp_x,bp_y,com2
           endwhile
           if (com2 ne 0) then begin
              if (com2 eq 10) then begin
                 point_x=fill
                 point_y=fill
              endif else begin
                 print,'*** Command Not Available ***'
              endelse
           endif else begin
              if (xtype eq 0) then begin
                 point_x=float((bp_x-bp_x_offset)*cos(rot_angle)+$
                         (bp_y-bp_y_offset)*sin(rot_angle))*xscale+xmin
              endif else begin
                 point_x=10^(float((bp_x-bp_x_offset)*cos(rot_angle)+$
                           (bp_y-bp_y_offset)*sin(rot_angle))*xscale+xmin)
              endelse
              if (ytype eq 0) then begin
                 point_y=float(-1*(bp_x-bp_x_offset)*sin(rot_angle)+$
                            (bp_y-bp_y_offset)*cos(rot_angle))*yscale+ymin
              endif else begin
                 point_y=10^(float(-1*(bp_x-bp_x_offset)*sin(rot_angle)+$
                             (bp_y-bp_y_offset)*cos(rot_angle))*yscale+ymin)
              endelse
           endelse
           x_save(edt_line-1,pos)=point_x
           y_save(edt_line-1,pos)=point_y
        end
     5: begin  ; INSERT DATA
           bpd_data,data_x,data_y
           temp2_x=x_save(edt_line-1,pos+1:n_pnts(edt_line-1)-1)
           temp2_y=y_save(edt_line-1,pos+1:n_pnts(edt_line-1)-1)
           n_x=n_elements(data_x)
           if (n_pnts(edt_line-1)+n_x gt n_save) then begin
              temp_x=fltarr(lines,n_pnts(edt_line-1)+n_x)
              temp_y=fltarr(lines,n_pnts(edt_line-1)+n_x)
              for i=0,lines-1 do begin
                 temp_x(i,0:n_pnts(i)-1)=x_save(i,0:n_pnts(i)-1)
                 temp_y(i,0:n_pnts(i)-1)=y_save(i,0:n_pnts(i)-1)
              endfor
              x_save=temp_x
              y_save=temp_y
              n_save=n_pnts(edt_line-1)+n_x
           endif
           x_save(edt_line-1,pos+1:pos+n_x)=data_x
           y_save(edt_line-1,pos+1:pos+n_x)=data_y
           x_save(edt_line-1,pos+n_x+1:pos+n_x+n_elements(temp2_x))=temp2_x
           y_save(edt_line-1,pos+n_x+1:pos+n_x+n_elements(temp2_y))=temp2_y
           n_pnts(edt_line-1)=n_pnts(edt_line-1)+n_x
        end
     6: begin  ; MOVE FORWARD
           pos=pos+1
           if (pos gt n_pnts(edt_line-1)-1) then pos=n_pnts(edt_line-1)-1
        end
     7: begin  ; MOVE BACKWARD
           pos=pos-1
           if (pos lt 0) then pos=0
        end
    10: begin  ; REPLACE POINT WITH FILL
           x_save(edt_line-1,pos)=fill
           y_save(edt_line-1,pos)=fill
        end
   else: print,'*** Command Not Available ***'
   endcase
   plot,x_save(0,0:n_pnts(0)-1),y_save(0,0:n_pnts(0)-1),$
        psym=-3,max_value=fill-1.,xtype=xtype,ytype=ytype 
   if lines ge 2 then for i=2,lines do $
       oplot,x_save(i-1,0:n_pnts(i-1)-1),$
             psym=-3,y_save(i-1,0:n_pnts(i-1)-1),max_value=fill-1.
   if (err eq 1) then begin
      if (x_save(edt_line-1,pos) ge fill) then begin
         if (pos ne 0) then begin
            oplot,[x_save(edt_line-1,pos-1)],$
                  [!y.crange(1)-y_save(edt_line-1,pos-1)+!y.crange(0)],psym=5
         endif else begin
            oplot,[x_save(edt_line-1,pos+1)],$
                  [!y.crange(1)-y_save(edt_line-1,pos+1)+!y.crange(0)],psym=5
         endelse
      endif else begin
         oplot,[x_save(edt_line-1,pos)],[y_save(edt_line-1,pos)],psym=6
      endelse
   endif
endwhile
;
return
end
