;+
; Name: LINFILL.PRO
; Purpose: Fill gaps in array data using linear interpolation.
; Category: Array routine.
; Calling sequence: LINFILL,A,I1,I2
; Inputs: A = array to operate on.
;         I1, I2 = indices into array A giving the last good
;             value before a data gap and the first good value
;             after a data gap.
; Outputs: A = updated array.
; Procedure: do linear interpolation.
; Modification history: RES,  JHU-APL,  6 Mar, 1985.
;-

	PRO LINFILL,A,I1,I2

	V1 = A(I1)
	V2 = A(I2)

	SC = (V2-V1)/(I2-I1)

	FOR I = I1+1, I2-1 DO A(I) = (I-I1)*SC + V1

	RETURN

	END
