;+
; NAME:
;	CIRCLE_ARGS
; PURPOSE:
;	Returns angles in radians needed to draw a circle with line segments.
;	The first and last angles are 0 and 2*pi to give a closed circle.
; CALLING SEQUENCE:
;	Result = CIRCLE_ARGS( NSEG )
; INPUTS:
;	NSEG = Number of segments to be used to draw circle.
; OUTPUTS:
;	Result = Float vector of length NSEG+1. First element is 0.0, last is
;	   2*pi, others are regularly spaced between.
; MODIFICATION HISTORY:
;	Ian Grant, HIA/NRCC, August 1990.
;-

function circle_args, nseg

return, 2.0*!pi/nseg * findgen(nseg+1)
end
