;+
; NAME:
;	STRCONCATENATE
; PURPOSE:
;	Concatenate elements of a string array, with optional separators.
; CALLING SEQUENCE:
;	Result = STRCONCATENATE( STRARRAY, SEPARATOR )
; INPUTS:
;	STRARRAY = String array. Strings to be concatenated.
; OPTIONAL INPUT PARAMETERS:
;	SEPARATOR = Scalar string. String to be used as separator.
;	   Default '' (null string), giving no separators in Result).
; OUTPUTS:
;	Result = Scalar string. The elements of STRARRAY concatenated, except 
;	   that SEPARATOR is inserted between each pair of elements.
; PROCEDURE:
; MODIFICATION HISTORY:
;	Ian Grant, HIA/NRCC: IDL2.
;	IFG,  5 Feb 1993: Added ON_ERROR.
;-

function strconcatenate, strarray, separator

on_error, 2
if n_params() eq 1 then separator = ''
str = strarray(0)
for i=1,n_elements(strarray)-1 do $
   str = str + separator + strarray(i)
return, str
end
