;+
; NAME:
;	LEADDIM1
; PURPOSE:
;	Add a leading dimension of 1 to an array.
; CALLING SEQUENCE:
;	Result = LEADDIM1(ARR)
; INPUTS:
;	ARR = Any array.
; OUTPUTS:
;	Result = Array of dimensions (1, n0, n1, ..., nn), where ARR has
;	   dimensions (n0, n1, ..., nn). Elements have the values from ARR.
; RESTRICTIONS:
;	ARR may not be a scalar.
; PROCEDURE:
;	 Uses SIZE and REFORM.
; MODIFICATION HISTORY:
;	Ian Grant, 25-Oct-1990, IDL1
;	IFG  6 Feb 1991:  No changes needed for IDL2.
;	IFG, 23 Dec 1992: Added ON_ERROR.
;-

function leaddim1, arr

on_error, 0
s = size([arr])
;stop
;print,s
return, reform([arr],[1,s(1:s(0))])
end
